# Custom region/language

Batch allows you to set a custom region or a custom language that will override the value detected by the SDK. By default, Batch collects the language and the country of your users' devices.

Setting a custom region/language is useful if:

* You don't want to use the values detected by Batch.
* Your users can choose their own language or region for localization purposes.

![Custom locale](/files/JfgYJWbzQUl3TlW0U7Of)

**Writing custom region/language**

{% tabs %}
{% tab title="Swift" %}

```swift
BatchProfile.editor { editor in
    try? editor.setLanguage("en") // Language must be 2 chars, lowercase, ISO 639 formatted
    try? editor.setRegion("US") // Region must be 2 chars, uppercase, ISO 3166 formatted
    // If you prefer to use BatchProfile.editor() with local variable instead of usiong a closure,
    // remember to use editor.save() afterwards so that the changes are taken into account.
}
```

{% endtab %}

{% tab title="Objective-C" %}

```objectivec
[BatchProfile editWithBlock:^(BatchProfileEditor * _Nonnull editor) {
    [editor setRegion:@"en" error:nil]; // Language must be 2 chars, lowercase, ISO 639 formatted
    [editor setRegion:@"US" error: nil]; // Region must be 2 chars, uppercase, ISO 3166 formatted
    // If you prefer to use [BatchProfile editor] instead of `editWithBlock`,
    // remember to use [editor save] afterwards so that the changes are taken into account.
}];
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
If you call `editor` method before `startWithAPIKey` it will return nil. You should always call it after you started the SDK, and check nullity to be safe.
{% endhint %}

**Reading custom region/language**

Keep in mind that the data returned is only about your installation and not your Profile since it may be updated from another source.

{% tabs %}
{% tab title="Swift" %}

```swift
// This is how you retrieve your custom values. Values are nil by default.
let language = BatchUser.language()
let region = BatchUser.region()
```

{% endtab %}

{% tab title="Objective-C" %}

```objectivec
// This is how you retrieve your custom values. Values are nil by default.
NSString *language = [BatchUser language];
NSString *region = [BatchUser region];
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://doc.batch.com/developer/sdk/ios/profile-data/custom-locale.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
